import os
import time
from typing import Optional
from threading import RLock, Thread, Event
from queue import SimpleQueue
import rclpy
import rclpy.task
import rclpy.action
import rclpy.executors
from rclpy.callback_groups import MutuallyExclusiveCallbackGroup
from rclpy.executors import SingleThreadedExecutor
{% for s in skills %}
from {{ skillset }}_managers.action import {{ s.name|action_name }}
{% endfor %}
from .logic import *
from .resourceset_interface import ResourceSet

{% for s in skills %}
class {{ s.name|action_name }}Interface:
    def __init__(self, **kwargs):
        self.__name = '{{ s.name }}'
        self.__node = rclpy.create_node(f"_{{ skillset }}_interface_{self.__name}_{os.getpid()}_{int(time.time())}", use_global_arguments=False, **kwargs)
        self.__executor = SingleThreadedExecutor()
        self.__executor.add_node(self.__node)
        self.__queue = SimpleQueue()
        self.__running = Event()
        self.__running.set()
        self.__rlock = RLock()
        self.__thread = Thread(target=self.__spin)
        self.__thread.start()

        self.__state = None
        self.__progress = None
        # formula for preconditions
        self.__formula_pre = dict()
        {% for pre in s.preconditions|selectattr('resource') %}
        self.__formula_pre['{{ pre.name }}'] = {{ pre.resource|expression }}
        {% endfor %}
        self.__client = rclpy.action.client.ActionClient(self.__node, {{ s.name|action_name }}, 
                    f"skill/{ self.__name }", callback_group=MutuallyExclusiveCallbackGroup())
        self.__action_spec = {{ s.name|action_name }}
        self.__gh = None
        self.__send_goal_future = None
        self.__get_result_future = None
        self.__cancel_goal_future = None
        
    def __del__(self):
        self.__executor.shutdown()
        self.__thread.join()
        
    def destroy_node(self):
        self.__node.get_logger().debug(f"destroying node")
        self.__node.destroy_node()

    def __spin(self):
        while rclpy.ok():
            try:
                self.__executor.spin_once(timeout_sec=0.1)
            except Exception as e:
                return
    
    @property
    def name(self):
        """Skill name"""
        return self.__name

    @property
    def node(self):
        """Skill interface ROS node"""
        return self.__node

    ## Server connections
    @property
    def ready(self) -> bool:
        return self.__client.server_is_ready()

    def __nonzero__(self):
        return self.ready

    def __bool__(self):
        return self.ready

    def wait_manager(self, timeout: Optional[float] = None) -> bool:
        self.__node.get_logger().debug(f"Skill {self.__name} wait for manager server")
        return self.__client.wait_for_server(timeout_sec=timeout)

    ## Progress
    def __feedback_cb(self, feedback_msg):
        self.__node.get_logger().debug(f"received feedback {feedback_msg.feedback}")
        with self.__rlock:
            self.__progress = feedback_msg.feedback.progress

    @property
    def progress(self) -> float:
        """Progress value"""
        return self.__progress

    ## Preconditions
    def check_resource_precondition(self, resources: ResourceSet):
        for label, formula in self.__formula_pre.items():
            states = dict()
            for res in formula.symbols():
                states[res] = resources[res].get()
            if not formula.eval(states):
                return False
        return True

    ## Start
    def __goal_cb(self, future):
        self.__node.get_logger().debug("goal response received")
        self.__queue.put(future.result())

    def start(self, **kwargs) -> Optional[rclpy.task.Future] :
        """Start the skill execution.
        """
        #with self.__rlock:
        self.__progress = 0.0
        action_fields = self.__action_spec.Goal.get_fields_and_field_types()
        action_args = {k: v for k, v in kwargs.items() if k in action_fields}
        self.__send_goal_future = self.__client.send_goal_async(self.__action_spec.Goal(**action_args),
                                                                feedback_callback = self.__feedback_cb)
        self.__send_goal_future.add_done_callback(self.__goal_cb)
        self.__gh = self.__queue.get()
        if not self.__gh.accepted:
            self.__node.get_logger().warning(f"Skill {self.__name} execution rejected")
            self.__state = 'NV'
            return None

        self.__node.get_logger().debug(f"Skill {self.__name} execution accepted")
        self.__running.clear()
        self.__get_result_future = self.__gh.get_result_async()
        self.__get_result_future.add_done_callback(self.__done_cb)
        self.__state = 'RG'
        self.__node.get_logger().debug(f"Skill {self.__name} running... {self.running}")
        return self.__get_result_future

    def __done_cb(self, future):
        self.__node.get_logger().debug("future done")
        #with self.__rlock:
        result = future.result()
        self.__state = result.result.state
        self.__node.get_logger().debug(f"Received result {self.__state}")
        self.__running.set()
        self.__node.get_logger().debug(f"Skill {self.__name} running... {self.running}")
            
    def wait(self, timeout: Optional[float] = None) -> bool:
        """Wait for completion"""
        self.__node.get_logger().debug(f"Skill {self.__name} running? {self.running}")
        self.__node.get_logger().debug(f"{self.__name} wait until future complete")
        return self.__running.wait(timeout=timeout)

    @property
    def running(self) -> bool:
        return not self.__running.is_set()

    ## Result
    @property
    def result(self) -> str:
        """Final result"""
        return self.__state

    ## Interruption
    def interrupt(self):
        """Interrupt execution"""
        if self.running and self.__gh is not None:
            self.__cancel_goal_future = self.__gh.cancel_goal_async()
            self.__cancel_goal_future.add_done_callback(self.__goal_cb)
            result = self.__queue.get()
            if result.return_code != 0:
                self.__node.get_logger().warning(f"Skill {self.__name} interruption rejected")
                #self.__state = 'NV'
                return False

            self.__node.get_logger().debug(f"Skill {self.__name} interruption accepted")
            self.__cancel_result_future = self.__gh.get_result_async()
            self.__cancel_result_future.add_done_callback(self.__done_cb)
            self.__state = 'IG'
            self.__node.get_logger().debug(f"Skill {self.__name} running... {self.running}")
            return True
        return True
{% endfor %}
